#include "port_ini.h"


uint16_t delay_count; 


#define    DWT_CYCCNT    *(volatile unsigned long *)0xE0001004
#define    DWT_CONTROL   *(volatile unsigned long *)0xE0001000
#define    SCB_DEMCR     *(volatile unsigned long *)0xE000EDFC

// Прерывание - ЭТО ОБЯЗАТЕЛЬНО!!  
		 
void SysTick_Handler(void)
{
if (delay_count > 0)
       {
	delay_count --;
       } 
}		 

// Задержка Микро

void delay_us(uint32_t us)   // Микро секунды 10-6
{
	int32_t us_count_tick =  us * (SystemCoreClock/1000000);
	//разрешаем использовать счётчик
	SCB_DEMCR |= CoreDebug_DEMCR_TRCENA_Msk;
        //обнуляем значение счётного регистра
	DWT_CYCCNT  = 0;
        //запускаем счётчик
	DWT_CONTROL |= DWT_CTRL_CYCCNTENA_Msk; 
	while(DWT_CYCCNT < us_count_tick);
        //останавливаем счётчик
	DWT_CONTROL &= ~DWT_CTRL_CYCCNTENA_Msk;
	
}
// Задержка МиЛи

void delay_ms(uint32_t ms) // МиЛи секунды 10-3
{
	int32_t ms_count_tick =  ms * (SystemCoreClock/1000);
	//разрешаем использовать счётчик
	SCB_DEMCR |= CoreDebug_DEMCR_TRCENA_Msk;
         //обнуляем значение счётного регистра
	DWT_CYCCNT  = 0;
        //запускаем счётчик
	DWT_CONTROL|= DWT_CTRL_CYCCNTENA_Msk; 
	while(DWT_CYCCNT < ms_count_tick);
        //останавливаем счётчик
	DWT_CONTROL &= ~DWT_CTRL_CYCCNTENA_Msk;
	
} 
 void sdelay_ms(uint16_t delay_temp) 
{
	
delay_count = delay_temp;
	while (delay_count)
 {
  };
}


// Конфигурируем порты для управления светодиодами встроенными в плату

void GPIO_init(void)
{
      GPIO_InitTypeDef GPIO_InitStructure;                     // создаем структуру
	    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB,ENABLE);     // включаем тактирования порта В
	    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA,ENABLE);     // включаем тактирование порта А
	
 	//  Настройка порта под сверодиод -> выход PB0   
 					 
      GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1; 
      GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
      GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT; 
      GPIO_Init(GPIOB, &GPIO_InitStructure);
		
	// Светодиод на плате подключенный к порту выход РА 6 
      GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
	    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
      GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;	
      GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	    GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
	    GPIOA->ODR ^= GPIO_Pin_6;
	    GPIO_Init(GPIOA, &GPIO_InitStructure);
	    
  
	// Светодиод на плате подключенный к порту выход РА 7     
	    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
      GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
      GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
      GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
      GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	
      GPIOA->ODR ^= GPIO_Pin_7;
			GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	
}

// Конфигурируем порты для управления кнопками встроенными в плату
     void button_ini(void)
		 {
       RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOE,ENABLE);     // включаем тактирование порта А
			 
			 GPIO_InitTypeDef init_button;  

// Кнопка на плате подключенная к порту РЕ 3 
      init_button.GPIO_Pin = GPIO_Pin_3;	
			init_button.GPIO_Mode = GPIO_Mode_IN; 
      init_button.GPIO_Speed = GPIO_Low_Speed ;  
      init_button.GPIO_PuPd = GPIO_PuPd_UP;	
			GPIO_Init(GPIOE, &init_button); 
			 
   // Кнопка на плате подключенная к порту РЕ 4
      init_button.GPIO_Pin = GPIO_Pin_4;
			init_button.GPIO_Mode = GPIO_Mode_IN; 
      init_button.GPIO_Speed = GPIO_Low_Speed ;
      init_button.GPIO_PuPd = GPIO_PuPd_UP;
			GPIO_Init(GPIOE, &init_button);
		 }
		 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
// Конфигурируем USART2 

	
void USART2_Configuration(void)
{ 
	//  USART2 у которого:
  //  USART2 TX - PA2
  //  USART2 RX - PA3
	    GPIO_InitTypeDef  GPIO_InitStructure;   // Создаем структуру порта
      USART_InitTypeDef USART_InitStructure;  // Создаем структуру USART2
	
	    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE); //Включаем тактирование порта A
	    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE); //Включаем тактирование порта USART2	
	
	 // Можно сделать одной строчкой работает и так и так
	//  RCC_APB1PeriphClockCmd(RCC_AHB1Periph_GPIOA | RCC_APB1Periph_USART2,ENABLE);
	
      GPIO_PinAFConfig(GPIOA, GPIO_PinSource3, GPIO_AF_USART2); //Подключаем PA3 к TX USART2
      GPIO_PinAFConfig(GPIOA, GPIO_PinSource2, GPIO_AF_USART2); //Подключаем PA2 к RX USART2
	
	//Конфигурируем PA2 как альтернативную функцию -> TX UART2.
      GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
      GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
      GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
      GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
      GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
      GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	//Конфигурируем PA3 как альтернативную функцию -> RX UART. 
      GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
      GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
      GPIO_Init(GPIOA, &GPIO_InitStructure);
			
			// Конфигурируем настройки USART2 
      USART_InitStructure.USART_BaudRate = 115200; //Скорость обмена 115200 бод
      USART_InitStructure.USART_WordLength = USART_WordLength_8b; //Длина слова 8 бит
      USART_InitStructure.USART_StopBits = USART_StopBits_1; //1 стоп-бит
      USART_InitStructure.USART_Parity = USART_Parity_No ; //Без проверки четности
      USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //Без аппаратного контроля
      USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; //Включен передатчик и приемник USART2
      // Можно задать настройки по умолчанию строкой
			// USART_StructInit(&USART_InitStructure);

      USART_Init(USART2, &USART_InitStructure);  // Инициализируем структуру
      USART_Cmd(USART2, ENABLE); //Включаем UART
   
}

